/***********************************************\
* Common functions (simple SSL toolkit)		*
* (C) 2005 Digithell, Inc. (Pavel Strachota)	*
* file: service.h				*
\***********************************************/

#if !defined __SSL_service
#define __SSL_service

#include <openssl/bio.h>
#include <openssl/err.h>
#include <openssl/rand.h>
#include <openssl/ssl.h>
#include <openssl/x509v3.h>	// needed for post connection checks

#include "include/strings.h"

// functions shared by both client and server
void InitSSL();
void ReportError(char * error_string, bool is_fatal=true);
void ReportSSLError(char * error_string, bool is_fatal=true);
int LoadPassphrase(char * buf,int size,int flag,void  * userdata);
int VerifyCert(int verify_status, X509_STORE_CTX * store);

// shared data
extern const _string_ PASSFILE;
extern const int VERIFY_DEPTH;

#define DEFAULT_PORT "6001"

#endif	// __SSL_service
